diff --git a/subsys/net/l2/bluetooth.c b/subsys/net/l2/bluetooth.c
index 3494e97883bd7..c1b40664ebc76 100644
--- a/subsys/net/l2/bluetooth.c
+++ b/subsys/net/l2/bluetooth.c
@@ -35,6 +35,8 @@
 #include "net_private.h"
 #include "ipv6.h"
 
+#define BUF_TIMEOUT K_MSEC(50)
+
 #define L2CAP_IPSP_PSM 0x0023
 #define L2CAP_IPSP_MTU 1280
 
@@ -185,7 +187,10 @@ static void ipsp_recv(struct bt_l2cap_chan *chan, struct net_buf *buf)
 		net_buf_frags_len(buf));
 
 	/* Get packet for bearer / protocol related data */
-	pkt = net_pkt_get_reserve_rx(0, K_FOREVER);
+	pkt = net_pkt_get_reserve_rx(0, BUF_TIMEOUT);
+	if (!pkt) {
+		return;
+	}
 
 	/* Set destination address */
 	net_pkt_ll_dst(pkt)->addr = ctxt->src.val;
diff --git a/subsys/net/l2/ieee802154/ieee802154.c b/subsys/net/l2/ieee802154/ieee802154.c
index 6df2d4a35b054..6214de92f2cb7 100644
--- a/subsys/net/l2/ieee802154/ieee802154.c
+++ b/subsys/net/l2/ieee802154/ieee802154.c
@@ -38,6 +38,8 @@
 
 #ifdef CONFIG_NET_DEBUG_L2_IEEE802154_DISPLAY_PACKET
 
+#define BUF_TIMEOUT K_MSEC(50)
+
 #include "net_private.h"
 
 static inline void pkt_hexdump(const char *title, struct net_pkt *pkt,
@@ -75,12 +77,16 @@ static inline void ieee802154_acknowledge(struct net_if *iface,
 		return;
 	}
 
-	pkt = net_pkt_get_reserve_tx(IEEE802154_ACK_PKT_LENGTH, K_FOREVER);
+	pkt = net_pkt_get_reserve_tx(IEEE802154_ACK_PKT_LENGTH, BUF_TIMEOUT);
 	if (!pkt) {
 		return;
 	}
 
-	frag = net_pkt_get_frag(pkt, K_FOREVER);
+	frag = net_pkt_get_frag(pkt, BUF_TIMEOUT);
+	if (!frag) {
+		net_pkt_unref(pkt);
+		return;
+	}
 
 	net_pkt_frag_insert(pkt, frag);
 
diff --git a/subsys/net/l2/ieee802154/ieee802154_fragment.c b/subsys/net/l2/ieee802154/ieee802154_fragment.c
index 280d820c3a80f..ce336f0917853 100644
--- a/subsys/net/l2/ieee802154/ieee802154_fragment.c
+++ b/subsys/net/l2/ieee802154/ieee802154_fragment.c
@@ -26,6 +26,8 @@
 #include "6lo.h"
 #include "6lo_private.h"
 
+#define BUF_TIMEOUT K_MSEC(50)
+
 #define FRAG_REASSEMBLY_TIMEOUT \
 	K_SECONDS(CONFIG_NET_L2_IEEE802154_REASSEMBLY_TIMEOUT)
 #define REASS_CACHE_SIZE CONFIG_NET_L2_IEEE802154_FRAGMENT_REASS_CACHE_SIZE
@@ -84,7 +86,7 @@ static inline struct net_buf *prepare_new_fragment(struct net_pkt *pkt,
 {
 	struct net_buf *frag;
 
-	frag = net_pkt_get_frag(pkt, K_FOREVER);
+	frag = net_pkt_get_frag(pkt, BUF_TIMEOUT);
 	if (!frag) {
 		return NULL;
 	}
diff --git a/subsys/net/l2/ieee802154/ieee802154_frame.c b/subsys/net/l2/ieee802154/ieee802154_frame.c
index 211ea63706298..5a7c82b4c3abb 100644
--- a/subsys/net/l2/ieee802154/ieee802154_frame.c
+++ b/subsys/net/l2/ieee802154/ieee802154_frame.c
@@ -29,6 +29,8 @@
 #include "ieee802154_frame.h"
 #include "ieee802154_security.h"
 
+#define BUF_TIMEOUT K_MSEC(50)
+
 #ifdef CONFIG_NET_L2_IEEE802154_SECURITY
 const u8_t level_2_tag_size[4] = {
 	0,
@@ -821,12 +823,12 @@ ieee802154_create_mac_cmd_frame(struct ieee802154_context *ctx,
 	struct net_buf *frag;
 	u8_t *p_buf;
 
-	pkt = net_pkt_get_reserve_tx(0, K_FOREVER);
+	pkt = net_pkt_get_reserve_tx(0, BUF_TIMEOUT);
 	if (!pkt) {
 		return NULL;
 	}
 
-	frag = net_pkt_get_frag(pkt, K_FOREVER);
+	frag = net_pkt_get_frag(pkt, BUF_TIMEOUT);
 	if (!frag) {
 		goto error;
 	}
diff --git a/subsys/net/lib/coap/coap.c b/subsys/net/lib/coap/coap.c
index 05990cac6c616..fc01b7fd3e3ff 100644
--- a/subsys/net/lib/coap/coap.c
+++ b/subsys/net/lib/coap/coap.c
@@ -382,6 +382,22 @@ int coap_packet_parse(struct coap_packet *cpkt, struct net_pkt *pkt,
 	return 0;
 }
 
+#define append(pkt, type, value)					\
+	do {								\
+		if (!net_pkt_append_##type##_timeout(pkt, value,	\
+						     PKT_WAIT_TIME)) {	\
+			return -ENOMEM;					\
+		}							\
+	} while (0)
+
+#define append_all(pkt, size, value)					\
+	do {								\
+		if (!net_pkt_append_all(pkt, size, value,		\
+					PKT_WAIT_TIME)) {		\
+			return -ENOMEM;					\
+		}							\
+	} while (0)
+
 int coap_packet_init(struct coap_packet *cpkt, struct net_pkt *pkt,
 		     u8_t ver, u8_t type, u8_t tokenlen,
 		     u8_t *token, u8_t code, u16_t id)
@@ -403,9 +419,9 @@ int coap_packet_init(struct coap_packet *cpkt, struct net_pkt *pkt,
 	hdr |= (type & 0x3) << 4;
 	hdr |= tokenlen & 0xF;
 
-	net_pkt_append_u8(pkt, hdr);
-	net_pkt_append_u8(pkt, code);
-	net_pkt_append_be16(pkt, id);
+	append(pkt, u8, hdr);
+	append(pkt, u8, code);
+	append(pkt, be16, id);
 
 	if (token && tokenlen) {
 		res = net_pkt_append_all(pkt, tokenlen, token, PKT_WAIT_TIME);
@@ -906,7 +922,8 @@ struct coap_observer *coap_find_observer_by_addr(
 
 int coap_packet_append_payload_marker(struct coap_packet *cpkt)
 {
-	return net_pkt_append_u8(cpkt->pkt, COAP_MARKER) ? 0 : -EINVAL;
+	return net_pkt_append_u8_timeout(cpkt->pkt, COAP_MARKER,
+					 PKT_WAIT_TIME) ? 0 : -EINVAL;
 }
 
 int coap_packet_append_payload(struct coap_packet *cpkt, u8_t *payload,
@@ -958,18 +975,18 @@ static int encode_option(struct coap_packet *cpkt, u16_t code,
 	option_header_set_delta(&opt, opt_delta);
 	option_header_set_len(&opt, opt_len);
 
-	net_pkt_append_u8(cpkt->pkt, opt);
+	append(cpkt->pkt, u8, opt);
 
 	if (delta_size == 1) {
-		net_pkt_append_u8(cpkt->pkt, (u8_t) delta_ext);
+		append(cpkt->pkt, u8, (u8_t) delta_ext);
 	} else if (delta_size == 2) {
-		net_pkt_append_be16(cpkt->pkt, delta_ext);
+		append(cpkt->pkt, be16, delta_ext);
 	}
 
 	if (len_size == 1) {
-		net_pkt_append_u8(cpkt->pkt, (u8_t) len_ext);
+		append(cpkt->pkt, u8, (u8_t) len_ext);
 	} else if (delta_size == 2) {
-		net_pkt_append_be16(cpkt->pkt, len_ext);
+		append(cpkt->pkt, be16, len_ext);
 	}
 
 	if (len && value) {
diff --git a/subsys/net/lib/coap/coap_link_format.c b/subsys/net/lib/coap/coap_link_format.c
index c96bae062ded4..0d856c12c1ba7 100644
--- a/subsys/net/lib/coap/coap_link_format.c
+++ b/subsys/net/lib/coap/coap_link_format.c
@@ -547,11 +547,18 @@ static int format_uri(const char * const *path, struct net_pkt *pkt)
 
 		p++;
 		if (*p) {
-			net_pkt_append_u8(pkt, (u8_t) '/');
+			res = net_pkt_append_u8_timeout(pkt, (u8_t) '/',
+							PKT_WAIT_TIME);
+			if (!res) {
+				return -ENOMEM;
+			}
 		}
 	}
 
-	net_pkt_append_u8(pkt, (u8_t) '>');
+	res = net_pkt_append_u8_timeout(pkt, (u8_t) '>', PKT_WAIT_TIME);
+	if (!res) {
+		return -ENOMEM;
+	}
 
 	return 0;
 }
@@ -575,12 +582,19 @@ static int format_attributes(const char * const *attributes,
 
 		attr++;
 		if (*attr) {
-			net_pkt_append_u8(pkt, (u8_t) ';');
+			res = net_pkt_append_u8_timeout(pkt, (u8_t) ';',
+							PKT_WAIT_TIME);
+			if (!res) {
+				return -ENOMEM;
+			}
 		}
 	}
 
 terminator:
-	net_pkt_append_u8(pkt, (u8_t) ';');
+	res = net_pkt_append_u8_timeout(pkt, (u8_t) ';', PKT_WAIT_TIME);
+	if (!res) {
+		return -ENOMEM;
+	}
 
 	return 0;
 }
diff --git a/subsys/net/lib/dns/llmnr_responder.c b/subsys/net/lib/dns/llmnr_responder.c
index 0d56ef176709f..e4e57da5efb47 100644
--- a/subsys/net/lib/dns/llmnr_responder.c
+++ b/subsys/net/lib/dns/llmnr_responder.c
@@ -39,7 +39,7 @@
 static struct net_context *ipv4;
 static struct net_context *ipv6;
 
-#define BUF_ALLOC_TIMEOUT MSEC(100)
+#define BUF_ALLOC_TIMEOUT K_MSEC(100)
 
 /* This value is recommended by RFC 1035 */
 #define DNS_RESOLVER_MAX_BUF_SIZE	512
@@ -134,22 +134,46 @@ static int bind_ctx(struct net_context *ctx,
 	return ret;
 }
 
-static void setup_dns_hdr(struct net_pkt *pkt, u16_t answers, u16_t dns_id)
+#define append(pkt, type, value)					\
+	do {								\
+		if (!net_pkt_append_##type##_timeout(pkt, value,	\
+						     BUF_ALLOC_TIMEOUT)) { \
+			ret = -ENOMEM;					\
+			goto drop;					\
+		}							\
+	} while (0)
+
+#define append_all(pkt, size, value)					\
+	do {								\
+		if (!net_pkt_append_all(pkt, size, value,		\
+					BUF_ALLOC_TIMEOUT)) {		\
+			ret = -ENOMEM;					\
+			goto drop;					\
+		}							\
+	} while (0)
+
+
+static int setup_dns_hdr(struct net_pkt *pkt, u16_t answers, u16_t dns_id)
 {
 	u16_t flags;
+	int ret;
 
 	/* See RFC 1035, ch 4.1.1 and RFC 4795 ch 2.1.1 for header details */
 
 	flags = BIT(15);  /* This is response */
 
-	net_pkt_append_be16(pkt, dns_id);
-	net_pkt_append_be16(pkt, flags);   /* Flags and codes */
-	net_pkt_append_be16(pkt, 1);       /* Question count is set to 1, see
-					    * (RFC 4795 ch 2.1.1)
-					    */
-	net_pkt_append_be16(pkt, answers); /* Answer RR count */
-	net_pkt_append_be16(pkt, 0);       /* Authority RR count */
-	net_pkt_append_be16(pkt, 0);       /* Additional RR count */
+	append(pkt, be16, dns_id);
+	append(pkt, be16, flags);   /* Flags and codes */
+	append(pkt, be16, 1);       /* Question count is set to 1, see
+				     * (RFC 4795 ch 2.1.1)
+				     */
+	append(pkt, be16, answers); /* Answer RR count */
+	append(pkt, be16, 0);       /* Authority RR count */
+	append(pkt, be16, 0);       /* Additional RR count */
+
+	ret = 0;
+drop:
+	return ret;
 }
 
 static int add_question(struct net_pkt *pkt, enum dns_rr_type qtype,
@@ -157,6 +181,7 @@ static int add_question(struct net_pkt *pkt, enum dns_rr_type qtype,
 {
 	char *dot = query->data;
 	char *prev = NULL;
+	int ret;
 
 	while ((dot = strchr(dot, '.'))) {
 		if (!prev) {
@@ -172,33 +197,33 @@ static int add_question(struct net_pkt *pkt, enum dns_rr_type qtype,
 		*prev = strlen(prev) - 1;
 	}
 
-	if (!net_pkt_append_all(pkt, query->len + 1, query->data,
-				BUF_ALLOC_TIMEOUT)) {
-		return -ENOMEM;
-	}
-
-	net_pkt_append_be16(pkt, qtype);
+	append_all(pkt, query->len + 1, query->data);
+	append(pkt, be16, qtype);
+	append(pkt, be16, DNS_CLASS_IN);
 
-	net_pkt_append_be16(pkt, DNS_CLASS_IN);
-
-	return 0;
+	ret = 0;
+drop:
+	return ret;
 }
 
 static int add_answer(struct net_pkt *pkt, enum dns_rr_type qtype,
 		      struct net_buf *query, u32_t ttl,
 		      u16_t addr_len, const u8_t *addr)
 {
-	add_question(pkt, qtype, query);
-
-	net_pkt_append_be32(pkt, ttl);
-	net_pkt_append_be16(pkt, addr_len);
+	int ret;
 
-	if (!net_pkt_append_all(pkt, addr_len, addr,
-				BUF_ALLOC_TIMEOUT)) {
-		return -ENOMEM;
+	ret = add_question(pkt, qtype, query);
+	if (ret < 0) {
+		return ret;
 	}
 
-	return 0;
+	append(pkt, be32, ttl);
+	append(pkt, be16, addr_len);
+	append_all(pkt, addr_len, addr);
+
+	ret = 0;
+drop:
+	return ret;
 }
 
 static struct net_pkt *create_answer(struct net_context *ctx,
@@ -209,6 +234,7 @@ static struct net_pkt *create_answer(struct net_context *ctx,
 				     u16_t addr_len, const u8_t *addr)
 {
 	struct net_pkt *pkt;
+	int ret;
 
 	pkt = net_pkt_get_tx(ctx, BUF_ALLOC_TIMEOUT);
 	if (!pkt) {
@@ -217,12 +243,25 @@ static struct net_pkt *create_answer(struct net_context *ctx,
 
 	net_pkt_set_family(pkt, family);
 
-	setup_dns_hdr(pkt, 1, dns_id);
+	if (setup_dns_hdr(pkt, 1, dns_id) < 0) {
+		goto drop;
+	}
 
-	add_question(pkt, qtype, query);
-	add_answer(pkt, qtype, query, LLMNR_TTL, addr_len, addr);
+	ret = add_question(pkt, qtype, query);
+	if (ret < 0) {
+		goto drop;
+	}
+
+	ret = add_answer(pkt, qtype, query, LLMNR_TTL, addr_len, addr);
+	if (ret < 0) {
+		goto drop;
+	}
 
 	return pkt;
+
+drop:
+	net_pkt_unref(pkt);
+	return NULL;
 }
 
 #if defined(CONFIG_NET_IPV4)
diff --git a/subsys/net/lib/dns/mdns_responder.c b/subsys/net/lib/dns/mdns_responder.c
index 34e155def69ef..65f28aa86c901 100644
--- a/subsys/net/lib/dns/mdns_responder.c
+++ b/subsys/net/lib/dns/mdns_responder.c
@@ -107,21 +107,44 @@ static int bind_ctx(struct net_context *ctx,
 	return ret;
 }
 
-static void setup_dns_hdr(struct net_pkt *pkt, u16_t answers)
+#define append(pkt, type, value)					\
+	do {								\
+		if (!net_pkt_append_##type##_timeout(pkt, value,	\
+						     BUF_ALLOC_TIMEOUT)) { \
+			ret = -ENOMEM;					\
+			goto drop;					\
+		}							\
+	} while (0)
+
+#define append_all(pkt, size, value)					\
+	do {								\
+		if (!net_pkt_append_all(pkt, size, value,		\
+					BUF_ALLOC_TIMEOUT)) {		\
+			ret = -ENOMEM;					\
+			goto drop;					\
+		}							\
+	} while (0)
+
+static int setup_dns_hdr(struct net_pkt *pkt, u16_t answers)
 {
 	u16_t flags;
+	int ret;
 
 	/* See RFC 1035, ch 4.1.1 for header details */
 
 	flags = BIT(15);  /* This is response */
 	flags |= BIT(10); /* Authoritative Answer */
 
-	net_pkt_append_be16(pkt, 0);       /* Identifier, RFC 6762 ch 18.1 */
-	net_pkt_append_be16(pkt, flags);   /* Flags and codes */
-	net_pkt_append_be16(pkt, 0);       /* Question count */
-	net_pkt_append_be16(pkt, answers); /* Answer RR count */
-	net_pkt_append_be16(pkt, 0);       /* Authority RR count */
-	net_pkt_append_be16(pkt, 0);       /* Additional RR count */
+	append(pkt, be16, 0);       /* Identifier, RFC 6762 ch 18.1 */
+	append(pkt, be16, flags);   /* Flags and codes */
+	append(pkt, be16, 0);       /* Question count */
+	append(pkt, be16, answers); /* Answer RR count */
+	append(pkt, be16, 0);       /* Authority RR count */
+	append(pkt, be16, 0);       /* Additional RR count */
+
+	ret = 0;
+drop:
+	return ret;
 }
 
 static int add_answer(struct net_pkt *pkt, enum dns_rr_type qtype,
@@ -130,6 +153,7 @@ static int add_answer(struct net_pkt *pkt, enum dns_rr_type qtype,
 {
 	char *dot = query->data;
 	char *prev = NULL;
+	int ret;
 
 	while ((dot = strchr(dot, '.'))) {
 		if (!prev) {
@@ -145,25 +169,20 @@ static int add_answer(struct net_pkt *pkt, enum dns_rr_type qtype,
 		*prev = strlen(prev) - 1;
 	}
 
-	if (!net_pkt_append_all(pkt, query->len + 1, query->data,
-				BUF_ALLOC_TIMEOUT)) {
-		return -ENOMEM;
-	}
-
-	net_pkt_append_be16(pkt, qtype);
+	append_all(pkt, query->len + 1, query->data);
+	append(pkt, be16, qtype);
 
 	/* Bit 15 tells to flush the cache */
-	net_pkt_append_be16(pkt, DNS_CLASS_IN | BIT(15));
+	append(pkt, be16, DNS_CLASS_IN | BIT(15));
 
-	net_pkt_append_be32(pkt, ttl);
-	net_pkt_append_be16(pkt, addr_len);
+	append(pkt, be32, ttl);
+	append(pkt, be16, addr_len);
+	append_all(pkt, addr_len, addr);
 
-	if (!net_pkt_append_all(pkt, addr_len, addr,
-				BUF_ALLOC_TIMEOUT)) {
-		return -ENOMEM;
-	}
+	ret = 0;
 
-	return 0;
+drop:
+	return ret;
 }
 
 static struct net_pkt *create_answer(struct net_context *ctx,
@@ -173,6 +192,7 @@ static struct net_pkt *create_answer(struct net_context *ctx,
 				     u16_t addr_len, u8_t *addr)
 {
 	struct net_pkt *pkt;
+	int ret;
 
 	pkt = net_pkt_get_tx(ctx, BUF_ALLOC_TIMEOUT);
 	if (!pkt) {
@@ -181,11 +201,20 @@ static struct net_pkt *create_answer(struct net_context *ctx,
 
 	net_pkt_set_family(pkt, family);
 
-	setup_dns_hdr(pkt, 1);
+	if (setup_dns_hdr(pkt, 1) < 0) {
+		goto drop;
+	}
 
-	add_answer(pkt, qtype, query, MDNS_TTL, addr_len, addr);
+	ret = add_answer(pkt, qtype, query, MDNS_TTL, addr_len, addr);
+	if (ret < 0) {
+		goto drop;
+	}
 
 	return pkt;
+
+drop:
+	net_pkt_unref(pkt);
+	return NULL;
 }
 
 static int send_response(struct net_context *ctx, struct net_pkt *pkt,
diff --git a/subsys/net/lib/dns/resolve.c b/subsys/net/lib/dns/resolve.c
index 4366cbbe74ffa..5b8a47b9db51e 100644
--- a/subsys/net/lib/dns/resolve.c
+++ b/subsys/net/lib/dns/resolve.c
@@ -657,7 +657,7 @@ static int dns_write(struct dns_resolve_context *ctx,
 	}
 
 	ret = net_pkt_append_all(pkt, dns_data->len, dns_data->data,
-			      ctx->buf_timeout);
+				 ctx->buf_timeout);
 	if (ret < 0) {
 		ret = -ENOMEM;
 		goto quit;
